"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.generateIdsFilter = void 0;
const mongodb_1 = require("mongodb");
function generateIdsFilter(id) {
    if (!id)
        return null;
    let filters = [];
    // Valid ObjectId string
    if (typeof id === "string" && mongodb_1.ObjectId.isValid(id)) {
        filters.push({ _id: new mongodb_1.ObjectId(id) });
    }
    // Valid ObjectId
    else if (id instanceof mongodb_1.ObjectId) {
        filters.push({ _id: id });
    }
    // Just a string id
    else if (typeof id === "string") {
        filters.push({ id });
    }
    return filters.length ? { $or: filters } : null;
}
exports.generateIdsFilter = generateIdsFilter;
