"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.query = void 0;
const tslib_1 = require("tslib");
const lodash_1 = tslib_1.__importDefault(require("lodash"));
const mustache_1 = tslib_1.__importDefault(require("mustache"));
exports.query = {
    serialize(query) {
        if (typeof query === "undefined")
            return "";
        return JSON.stringify(query);
    },
    deserialize(data, ref) {
        if (typeof data !== "string" || !data)
            return null;
        try {
            const combinedData = mustache_1.default.render(data, ref);
            return JSON.parse(combinedData, (key, value) => {
                if (typeof value !== "string")
                    return value;
                return value.startsWith("$") ? lodash_1.default.get(ref, value) : value;
            });
        }
        catch (_a) {
            return null;
        }
    },
};
