"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.clear = void 0;
async function clear(redis, pattern) {
    let cursor = 0;
    const keyPrefix = redis.options.keyPrefix || "";
    const match = [keyPrefix, pattern, "*"].filter(Boolean).join("");
    while (cursor >= 0) {
        // scan, hscan, ... muast include prefix key to search
        const [cursorIndex, keys] = await redis.scan(cursor, "MATCH", match, "COUNT", 100);
        // When cursorIndex is "0", that mean no more data
        cursor = Number(cursorIndex) > 0 ? Number(cursorIndex) : -1;
        // But other function have to remove prefix first to execute succesfull
        if (keys.length) {
            const ids = keys.map((key) => key.replace(keyPrefix, ""));
            await redis.del(...ids);
        }
    }
}
exports.clear = clear;
